/* shell.c */
#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

#define sin60 0.866025
#define r 1.0

int main(argc,argv) int argc; char *argv[]; {
  setbuf(stdout, NULL); /* no buffering for output! */
  
  int nbsquares,square,linecolor,color;
  float linex,x,y1,y2;
  
  printf("\134documentclass[12pt,a4paper]{article}\n");
  printf("\134usepackage{lambda,ifthen,calc}\n");
  printf("\134usepackage{pstricks}\n");
  printf("\134begin{document}\n");
  printf("\134setlength{\134textwidth}{18cm}\n");
  printf("\134setlength{\134marginparwidth}{0cm}\n");
  printf("\134setlength{\134oddsidemargin}{-1in+1.5cm}\n");
  printf("\134setlength{\134evensidemargin}{-1in+1.5cm}\n");
  printf("\134setlength{\134textheight}{26.2cm}\n");
  printf("\134setlength{\134topmargin}{0cm}\n");
  printf("\134setlength{\134headheight}{0.7cm}\n");
  printf("\134setlength{\134headsep}{0.5cm}\n");
  printf("\134setlength{\134footskip}{0cm}\n");
  printf("\134setlength{\134voffset}{-1in+1cm}\n");
  printf("\134pagestyle{empty}\n");
  printf("\134begin{pspicture}(17,26)\n");
  
  linecolor=0;
  linex=0.0;/*r*sin60;*/
  y1=13.2;
  y2=13.2;
  for(nbsquares=11;nbsquares>5;nbsquares--) {
    x=linex;
    color=linecolor;
    for(square=1;square<=nbsquares;square++) {
      printf("\134pspolygon[fillstyle=");
      switch(color) {
        case 0: printf("none]"); break;
        case 1: printf("vlines]"); break;
        case 2: printf("crosshatch]"); break;
      }
      printf("(%f,%f)",x,y1+r);
      printf("(%f,%f)",x+r*sin60,y1+r/2);
      printf("(%f,%f)",x+r*sin60,y1-r/2);
      printf("(%f,%f)",x,y1-r);
      printf("(%f,%f)",x-r*sin60,y1-r/2);
      printf("(%f,%f)\n",x-r*sin60,y1+r/2);
      if(nbsquares!=11) { 
        printf("\134pspolygon[fillstyle=");
        switch(color) {
          case 0: printf("none]"); break;
          case 1: printf("vlines]"); break;
          case 2: printf("crosshatch]"); break;
        }
        printf("(%f,%f)",x,y2+r);
        printf("(%f,%f)",x+r*sin60,y2+r/2);
        printf("(%f,%f)",x+r*sin60,y2-r/2);
        printf("(%f,%f)",x,y2-r);
        printf("(%f,%f)",x-r*sin60,y2-r/2);
        printf("(%f,%f)\n",x-r*sin60,y2+r/2);
      }
      x+=2*r*sin60;
      color++;
      if(color==3) { color=0; }
    } /* next square */
    linecolor+=2;
    if(linecolor>=3) { linecolor-=3; }
    y1+=r*1.5;
    y2-=r*1.5;
    linex+=r*sin60;
  }
  
  printf("\134end{pspicture}\n");
  printf("\134end{document}\n");
  
  exit(0);
}
